${ var doc = require( "hopdoc" ) }
${ var path = require( "path" ) }
${ var ROOT = path.dirname( module.filename ) }

Hss
===

This module documents the HSS compiler and tools.

Use `require( hop.hss )` to use it.

Hss is a builtin CSS compiler. It enables inserting Hop values inside
CSS files. Hop values are inserted with the `${<span>$</span>}{` mark.

Example
-------

${ doc.include( ROOT + "/../../../examples/hss/README.md" ) }

${ <span class="label label-info">hss/hss.js</span> }

```hopscript
${ doc.include( ROOT + "/../../../examples/hss/hss.js", 14 ) }
```

${ <span class="label label-info">hss/hss.hss</span> }

```hss
${ doc.include( ROOT + "/../../../examples/hss/hss.hss", 14 ) }
```

Functions
---------

### hss.parseWebColor( color ) ###
[:@glyphicon glyphicon-tag function]

Parses a color string and returns the red, green, blue components.

Example:

```hopscript
hss.parseWebColor( "#45ffc2" );

```

### hss.makeWebColor( red, green, blue ) ###
[:@glyphicon glyphicon-tag function]

Creates an HSS suitable string representation of the color.

Example:

```hopscript
hss.makeWebColor( 0x45, 0xff, 0xc2 );

```

### hss.load( path ) ###
[:@glyphicon glyphicon-tag function]

Load a HSS style. 

### hss.eval( path ) ###
[:@glyphicon glyphicon-tag function]

Read a HSS style from a string.


Example
-------

${ doc.include( ROOT + "/../../../examples/md/README.md" ) }

${ <span class="label label-info">md/md.js</span> }

```hopscript
${ doc.include( ROOT + "/../../../examples/md/md.js", 14 ) }
```

${ <span class="label label-info">md/tex.hss</span> }

```hss
${ doc.include( ROOT + "/../../../examples/md/tex.hss", 14 ) }
```

${ <span class="label label-info">md/markdown.hss</span> }

```hss
${ doc.include( ROOT + "/../../../examples/md/markdown.hss", 14 ) }
```

