${ var doc = require( "hopdoc" ) }
${ var path = require( "path" ) }
${ var ROOT = path.dirname( module.filename ) }

Markdown
========

This module documents the builtin Markdown parser.

Use `require( 'markdown' )` to use it.

Hop.js extends the genuine markdown
[syntax](http://daringfireball.net/projects/markdown/syntax) by
supporting embedded Hop.js expressions.  As JavaScript template
strings, expression starting with the prefix `${<span>$</span>}{` are
evaluated and the result of this evaluation is added _as is_ in the parsed
HTML tree.

Functions
---------

### markdown.load( file ) ###
[:@glyphicon glyphicon-tag function]

Parse a markdown file. On success, returns an object with the following
properties:

 * `filename`: the markdown source file.
 * `charset`: the encoding charset of the source.
 * `XML`: the parsed HTML tree.

The evaluation environment of the embedded expressions contains the following
global variables:

 * `filename`: the source file.


### markdown.eval( string ) ###
[:@glyphicon glyphicon-tag function]

Parse a markdown string. On success the result is an object with the
following properties:

 * `obj`: the markdown source string.
 * `charset`: the encoding charset of the source.
 * `XML`: the parsed HTML tree.


HTML
----

### <markdown.MARKDOWN src=file charset fontifier> ###
[:@glyphicon glyphicon-tag tag]

A wrapper to the `markdown.eval` function that let's markdown documents
be directly inserted into HTML containers.

#### Example: ####

${ doc.include( ROOT + "/../../../examples/mdtag/README.md" ) }

${ <span class="label label-info">mdtag/mdtag.js</span> }

```hopscript
${ doc.include( ROOT + "/../../../examples/mdtag/mdtag.js", 14 ) }
```




